import bpy

addon_keymaps = []


def add_hotkey(keymap, space, region, identifier, event_type, value, property=None, ctrl=False, shift=False,
               alt=False, ):
    if bpy.context.window_manager:
        wm = bpy.context.window_manager
        if wm.keyconfigs.addon:
            kc = wm.keyconfigs.addon
            km = kc.keymaps.new(name=keymap, space_type=space, region_type=region)
            kmi = km.keymap_items.new(identifier, event_type, value,
                                      ctrl=ctrl, shift=shift, alt=alt,
                                      )
            if property:
                kmi.properties.name = property
            kmi.active = True
            addon_keymaps.append((km, kmi))

def remove_hotkey(keymap):
    ''' clears all addon level keymap hotkeys stored in addon_keymaps '''
    if bpy.context.window_manager:
        wm = bpy.context.window_manager
        if wm.keyconfigs.addon:
            kc = wm.keyconfigs.addon
            if kc.keymaps.get(keymap, False):

                km = kc.keymaps[keymap]

                for km, kmi in addon_keymaps:
                    km.keymap_items.remove(kmi)
                addon_keymaps.clear()

def get_hotkey_entry_item(km, kmi_name, kmi_value):
    """
    returns hotkey of specific type, with specific properties.name (keymap is not a dict, so referencing by keys is not enough
    if there are multiple hotkeys!)
    """
    for i, km_item in enumerate(km.keymap_items):
        if km.keymap_items.keys()[i] == kmi_name:
            if kmi_value:
                if km.keymap_items[i].properties.name == kmi_value:
                    return km_item
                else:
                    return None
            else:
                return km_item
    return None

def register():

    add_hotkey("3D View", 'VIEW_3D', 'WINDOW',
               "mlr.modal_lattice_res",
               'L', 'PRESS',)

    #


def unregister():
    remove_hotkey("3D View")
